package br.com.dreamsource.mobile.worders.forms.user;

import br.com.dreamsource.mobile.worders.WOrders;
import br.com.dreamsource.mobile.components.FormWOrders;
import br.com.dreamsource.mobile.worders.forms.core.Consts;
import br.com.dreamsource.mobile.worders.forms.core.DatabaseOpen;
import br.com.dreamsource.mobile.worders.pojo.UserPOJO;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.StringItem;
import javax.microedition.lcdui.TextField;

/**
 *
 * @author Elizeu Nogueira da Rosa Jr.
 * @version 0.1
 * @date 20.05.2007
 *
 */

public class Login extends FormWOrders {
    
    private StringItem siInformation;
    private StringItem siWarning;
    
    private TextField tfUserName;
    private TextField tfPasswd;
    
    public static final int LOGIN_TYPE_CREATE_DATABASE = 1;
    public static final int LOGIN_TYPE_SYSTEM_LOGIN = 2;
    
    private int loginType;
    
    public Login(CommandListener listener, WOrders midlet, int loginType) {
        super(listener, midlet, "Login");
        this.loginType = loginType;        
        this.createComponents();
    }
    
    private StringItem getSiInformation() {
        if (siInformation == null) {
            siInformation = new StringItem("Informa\u00E7ao", 
                    "\nEsta e a primeira inicializa\u00E7ao do sistema por favor, " +
                    "digite um nome de usuario e senha para inicializar o sistema.");
        }
        return siInformation;
    }

    private StringItem getSiWarning() {
        if (siWarning == null) {
            siWarning = new StringItem("Aten\u00E7ao", 
                    "\nGuarde bem os dados digitados, eles serao solicitados em todas " +
                    "as inicializa\u00E7oes do sistema.");
        }
        return siWarning;
    }
    
    private TextField getTfUserName() {
        if (tfUserName == null) {
            tfUserName = new TextField("Usuario", "", 10, TextField.ANY);
        }
        return tfUserName;
    }        
    
    private TextField getTfPasswd() {
        if (tfPasswd == null) {
            tfPasswd = new TextField("Senha", "", 10, TextField.PASSWORD);
        }
        return tfPasswd;
    }        
    
    protected void createComponents() {
        /* Essa verificaao e necessaria porque o contrutor chama esse metodo
         * mas o atributo loginType ainda nao foi setado
         */
        if (this.loginType != 0) {
            if (this.loginType == Login.LOGIN_TYPE_CREATE_DATABASE) {
                this.append(this.getSiInformation());
                this.append(this.getSiWarning());
            }
            this.append(this.getTfUserName());
            this.append(this.getTfPasswd());
            this.addCommand(this.getOkCommand());
            this.addCommand(this.getBackCommand());
        }
    }
    
    public void fireCommand(Command command) {
        if (command == this.okCommand) {
            if (this.loginType == Login.LOGIN_TYPE_CREATE_DATABASE) {
                this.midlet.returnCreateDatabase(this.tfUserName.getString(), this.tfPasswd.getString());
                this.midlet.destroyForm(this);
            } else
            if (this.loginType == Login.LOGIN_TYPE_SYSTEM_LOGIN) {
                UserPOJO userPOJO = new UserPOJO();
                userPOJO.setDbName(Consts.DATABASE_NAME);
                userPOJO.setConnectionURL(Consts.DATABASE_CONNETION_STRING);
                userPOJO.setUserName(this.tfUserName.getString());
                userPOJO.setPasswd(this.tfPasswd.getString());
                DatabaseOpen dbOpen = new DatabaseOpen(userPOJO, this.midlet, this);
            }
        } else
        if (command == this.backCommand) {
            if (this.loginType == Login.LOGIN_TYPE_CREATE_DATABASE) {
                this.midlet.closeApp();
            } else 
            if (this.loginType == Login.LOGIN_TYPE_SYSTEM_LOGIN) {
                this.midlet.closeApp();
            }
        }
    }
    
}
